import 'package:flutter/material.dart';
import 'package:flutter_gen/gen_l10n/app_localizations.dart';

class Strings {
  Strings._();

  static AppLocalizations? _latestLocalizations;

  static AppLocalizations of(BuildContext context) =>
      AppLocalizations.of(context) ?? latest;

  static AppLocalizations get latest {
    final appLocalizations = _latestLocalizations;
    if (appLocalizations == null) {
      throw 'Unable to load App Localizations';
    }
    return appLocalizations;
  }
}

class StringsLocaleWidget extends StatelessWidget {
  const StringsLocaleWidget({Key? key, required this.child}) : super(key: key);
  final Widget child;

  @override
  Widget build(BuildContext context) {
    Strings._latestLocalizations = AppLocalizations.of(context);
    return child;
  }
}

extension AppLocales on Locale {
  static Locale get localeEn => const Locale('en', '');

  static List<Locale> get values => <Locale>[
        AppLocales.localeEn,
      ];
}
