import 'package:yaml/yaml.dart';

class PolyglotContent {
  final String projectId;
  final String flutterInstance;
  final String mandatoryLanguage;
  final String path;
  final String l10nFilePath;
  final String sourceFilesPath;
  final String outputLocalizationFile;
  final bool setDefaultLanguage;
  final Map defaultCountryCode;

  PolyglotContent({
    required this.projectId,
    required this.flutterInstance,
    required this.mandatoryLanguage,
    required this.path,
    required this.l10nFilePath,
    required this.sourceFilesPath,
    required this.outputLocalizationFile,
    required this.setDefaultLanguage,
    required this.defaultCountryCode,
  });

  factory PolyglotContent.fromYaml(YamlMap yaml) {
    return PolyglotContent(
      projectId: yaml[':projects'][0][':id'].toString(),
      flutterInstance: yaml[':projects'][0][':flutterInstance'],
      mandatoryLanguage: yaml[':projects'][0][':mandatoryLanguage'],
      path: yaml[':projects'][0][':path'],
      l10nFilePath: yaml[':projects'][0][':l10nFilePath'],
      sourceFilesPath: yaml[':projects'][0][':sourceFilesPath'],
      outputLocalizationFile: yaml[':projects'][0][':outputLocalizationFile'],
      setDefaultLanguage: yaml[':projects'][0][':setDefaultLanguage'],
      defaultCountryCode: yaml[':projects'][0][':defaultCountryCode'] ?? {},
    );
  }
}
