import 'package:json_annotation/json_annotation.dart';
import 'package:polyglothq/src/common/model/language.dart';
import 'package:polyglothq/src/common/model/translation_key.dart';

part 'translation.g.dart';

@JsonSerializable(createToJson: false, fieldRename: FieldRename.snake)
class Translation {
  Translation(this.value, this.language, this.translationKey);

  factory Translation.fromJson(Map<String, dynamic> json) =>
      _$TranslationFromJson(json);

  final String? value;
  final Language? language;
  final TranslationKey? translationKey;

  @override
  String toString() {
    return 'Translation{value: $value}';
  }
}
