import 'package:get_it/get_it.dart';
import 'package:polyglothq/src/domain/arb_mapper.dart';
import 'package:polyglothq/src/domain/commands/command_init.dart';
import 'package:polyglothq/src/domain/commands/command_login.dart';
import 'package:polyglothq/src/domain/commands/command_projects.dart';
import 'package:polyglothq/src/domain/commands/command_pull.dart';
import 'package:polyglothq/src/domain/data/token_holder.dart';

void injectDependencies(GetIt getIt) {
  getIt.registerLazySingleton(() => TokenHolder());

  getIt.registerLazySingleton(() => ArbMapper());

  getIt.registerFactory(() => CommandInit(
        getIt.get(),
        getIt.get(),
        getIt.get(),
      ));

  getIt.registerFactory(() => CommandLogin(
        getIt.get(),
        getIt.get(),
      ));

  getIt.registerFactory(() => CommandProjects(
        getIt.get(),
        getIt.get(),
        getIt.get(),
      ));

  getIt.registerFactory(() => CommandPull(
        getIt.get(),
        getIt.get(),
        getIt.get(),
        getIt.get(),
      ));
}
