import 'package:polyglothq/src/common/model/language.dart';
import 'package:polyglothq/src/common/model/project.dart';
import 'package:polyglothq/src/common/model/translation.dart';
import 'package:polyglothq/src/common/model/user_request.dart';
import 'package:polyglothq/src/common/model/user_response.dart';

abstract class ApiRepository {
  Future<UserResponse> login(UserRequest userRequest);

  Future<List<Language>> getLanguages(String projectId);

  Future<List<Translation>> getTranslations(
      String projectId, String languageId);

  Future<List<Project>> getProjects();
}
