import 'dart:convert';
import 'dart:io';

import 'package:polyglothq/src/domain/repository/local_repository.dart';

class LocalRepositoryImpl implements LocalRepository {
  @override
  Future<void> saveFile(String fileName, String content) async {
    final file = File(fileName);
    await file.create(recursive: true);
    await file.writeAsString(content, mode: FileMode.write);
  }

  @override
  Future<String> readFile(String fileName) async {
    if (await FileSystemEntity.isDirectory(fileName)) {
      throw ('error: $fileName is a directory');
    } else {
      final lines = utf8.decoder
          .bind(File(fileName).openRead())
          .transform(const LineSplitter());
      return lines.first;
    }
  }
}
