import 'dart:io';

import 'package:polyglothq/src/domain/data/token_holder.dart';
import 'package:polyglothq/src/domain/repository/token_repository.dart';

class TokenRepositoryImpl implements TokenRepository {
  TokenRepositoryImpl(this._tokenHolder);

  final TokenHolder _tokenHolder;

  @override
  Future<void> saveToken(String token) async {
    await Process.run('security', [
      'add-generic-password',
      '-s',
      'polyglothq',
      '-a',
      'polyglot_token',
      '-w',
      token
    ]);
  }

  @override
  Future<bool> loadToken() async {
    try {
      final token = await _readToken();
      _tokenHolder.token = token;
      return true;
    } catch (e) {
      return false;
    }
  }

  Future<String> _readToken() async {
    try {
      final token = await Process.run('security', [
        'find-generic-password',
        '-w',
        '-s',
        'polyglothq',
        '-a',
        'polyglot_token'
      ]);
      final error = token.stderr;
      if (error.isNotEmpty) throw error;
      return token.stdout.toString().trim();
    } catch (e) {
      rethrow;
    }
  }
}
