import 'package:dio/dio.dart';
import 'package:polyglothq/src/domain/data/token_holder.dart';

class TokenInterceptor extends Interceptor {
  TokenInterceptor(this._tokenHolder);

  final TokenHolder _tokenHolder;

  static const String authorization = 'X-Auth-Token';

  @override
  Future<void> onRequest(
      RequestOptions options, RequestInterceptorHandler handler) async {
    if (_tokenHolder.token != null) {
      options.headers[authorization] = _tokenHolder.token;
    }
    super.onRequest(options, handler);
  }
}
